(***********************************************************************

                       DATE AND TIME SUBROUTINES
                       Author: Glen F. Marshall

These functions return system date (SysDate), system time (SysTime),
day-of-week (SysDay), and name-of-month (SysMonth).

***********************************************************************)

type
  DateTimeResult = string[8];
  DateNameResult = string[9];

function SysDate: DateTimeResult;
  begin
    inline($B4/$2A/$CD/$21/$8B/$C1/$BB/$30/$30/$B9/$0A/$64/$F6/$F5/$8A/
           $C4/$32/$E4/$F6/$F1/$0B/$C3/$89/$86/$0B/$00/$C6/$86/$0A/$00/
           $2F/$8A/$C2/$32/$E4/$F6/$F1/$0B/$C3/$89/$86/$08/$00/$C6/$86/
           $07/$00/$2F/$8A/$C6/$32/$E4/$F6/$F1/$0B/$C3/$89/$86/$05/$00/
           $C6/$46/$04/$08);
  end {SysDate};

function SysTime: DateTimeResult;
  begin
    inline($B4/$2C/$CD/$21/$8A/$C5/$BB/$30/$30/$B5/$0A/$32/$E4/$F6/$F5/
           $0B/$C3/$89/$86/$05/$00/$C6/$86/$07/$00/$3A/$8A/$C1/$32/$E4/
           $F6/$F5/$0B/$C3/$89/$86/$08/$00/$C6/$86/$0A/$00/$3A/$8A/$C6/
           $32/$E4/$F6/$F5/$0B/$C3/$89/$86/$0B/$00/$C6/$46/$04/$08);
  end {SysTime};

function SysDay: DateNameResult;
  const
    Day: array[0..6] of DateNameResult
         = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday',
            'Saturday');
  var
    i: byte;
  begin
    inline($B4/$2A/$CD/$21/$88/$86/i);
    SysDay := Day[i];
  end {SysDay};

function SysMonth: DateNameResult;
  const
    Month: array[1..12] of DateNameResult
           = ('January','February','March','April','May','June','July',
              'August','September','October','November','December');
  var
    i: byte;
  begin
    inline($B4/$2A/$CD/$21/$88/$B6/i);
    SysMonth := Month[i];
  end {SysMonth};
